/************************************************************************************************
 * Copyright  (c) 2011, 2012, 2013 University of Pennsylvania
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without a
 * written agreement is hereby granted, provided that the above copyright
 * notice and this paragraph and the following two paragraphs appear in
 * all copies.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF PENNSYLVANIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF PENNSYLVANIA
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF PENNSYLVANIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON
 * AN "AS IS" BASIS, AND THE UNIVERSITY OF PENNSYLVANIA HAS NO OBLIGATIONS TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 ***********************************************************************************************/

/*** Leading 1 search ***/
/***	
Author: Edin Kadric
	IC Group, University of Pennsylvania

Notes: Code based on the architecture described in 
	"Accurate Parallel Floating-Point Accumulation", in Arith 2013

***/

// Returns index of "Most Significant One" in ip_string

import Types::*;
import Vector::*;

	function Index64 find_mso(Mantissa54 ip_string);     

		return (ip_string[53-0]==1)?0:((ip_string[53-1]==1)?1:((ip_string[53-2]==1)?2:((ip_string[53-3]==1)?3:((ip_string[53-4]==1)?4:((ip_string[53-5]==1)?5:((ip_string[53-6]==1)?6:((ip_string[53-7]==1)?7:
			((ip_string[53-8]==1)?8:((ip_string[53-9]==1)?9:((ip_string[53-10]==1)?10:((ip_string[53-11]==1)?11:((ip_string[53-12]==1)?12:((ip_string[53-13]==1)?13:((ip_string[53-14]==1)?14:((ip_string[53-15]==1)?15:
			((ip_string[53-16]==1)?16:((ip_string[53-17]==1)?17:((ip_string[53-18]==1)?18:((ip_string[53-19]==1)?19:((ip_string[53-20]==1)?20:((ip_string[53-21]==1)?21:((ip_string[53-22]==1)?22:((ip_string[53-23]==1)?23:
			((ip_string[53-24]==1)?24:((ip_string[53-25]==1)?25:((ip_string[53-26]==1)?26:((ip_string[53-27]==1)?27:((ip_string[53-28]==1)?28:((ip_string[53-29]==1)?29:((ip_string[53-30]==1)?30:((ip_string[53-31]==1)?31:
			((ip_string[53-32]==1)?32:((ip_string[53-33]==1)?33:((ip_string[53-34]==1)?34:((ip_string[53-35]==1)?35:((ip_string[53-36]==1)?36:((ip_string[53-37]==1)?37:((ip_string[53-38]==1)?38:((ip_string[53-39]==1)?39:
			((ip_string[53-40]==1)?40:((ip_string[53-41]==1)?41:((ip_string[53-42]==1)?42:((ip_string[53-43]==1)?43:((ip_string[53-44]==1)?44:((ip_string[53-45]==1)?45:((ip_string[53-46]==1)?46:((ip_string[53-47]==1)?47:
			((ip_string[53-48]==1)?48:((ip_string[53-49]==1)?49:((ip_string[53-50]==1)?50:((ip_string[53-51]==1)?51:((ip_string[53-52]==1)?52:53))))))))))))))))))))))))))))))))))))))))))))))))))));
	endfunction

